import "./accordion.css";
import { defineComponent as s, openBlock as n, createElementBlock as l, mergeProps as d, createElementVNode as a, normalizeClass as r, withModifiers as c, toDisplayString as p, renderSlot as i, createCommentVNode as u, createBlock as h, resolveDynamicComponent as f, normalizeStyle as g } from "vue";
import { a as m } from "../../icons-ba8254f6.js";
import { _ as E } from "../../_plugin-vue_export-helper-dad06003.js";
const v = s({
  props: {
    clickOutside: {
      default: !1,
      type: Boolean
    },
    color: {
      default: "accent",
      type: String
    },
    expand: {
      required: !1,
      type: Boolean
    },
    noElevation: {
      required: !1,
      type: Boolean
    },
    title: {
      required: !1,
      type: String
    }
  },
  name: "sb-accordion",
  data() {
    return {
      localCollapsing: !1,
      localExpanding: !1,
      localExpanded: !1
    };
  },
  computed: {
    angleDown() {
      return m();
    },
    getAccordionStyles() {
      var e;
      if (this.localExpanding || this.localCollapsing) {
        const t = this.$refs[`${this.$.uid}-content`];
        if (t)
          return {
            height: `${((e = t.getBoundingClientRect()) == null ? void 0 : e.height) || 0}px`
          };
      }
      return {};
    }
  },
  methods: {
    handleClickOutsideAccordion(e) {
      const t = e.target, o = this.$refs.accordion;
      this.localExpanded && this.clickOutside && t && o && !o.contains(t) && !t.isSameNode(o) && this.handleToggle(!1);
    },
    handleToggle(e) {
      e && !this.localExpanded ? (this.localExpanding = !0, setTimeout(() => {
        this.localExpanding = !1, this.localExpanded = !0;
      }, 300)) : (this.localCollapsing = !0, setTimeout(() => {
        this.localCollapsing = !1, this.localExpanded = !1;
      }, 150));
    }
  },
  watch: {
    expand: {
      handler(e) {
        this.localExpanded = e || !1;
      },
      immediate: !0
    }
  },
  mounted() {
    document.addEventListener(
      "click",
      (e) => this.handleClickOutsideAccordion(e)
    );
  },
  unmounted() {
    document.removeEventListener(
      "click",
      (e) => this.handleClickOutsideAccordion(e)
    );
  }
});
const $ = {
  key: 0,
  class: "title"
}, y = {
  key: 1,
  class: "title"
};
function k(e, t, o, C, S, w) {
  return n(), l("div", d({
    class: ["accordion", {
      expanded: e.localExpanded || e.localExpanding,
      "no-elevation": e.noElevation
    }],
    ref: "accordion"
  }, { ...e.$attrs }), [
    a("div", {
      class: r(["header-wrapper", [e.color]]),
      onClick: t[0] || (t[0] = c((B) => e.handleToggle(!e.localExpanded), ["stop"]))
    }, [
      e.title ? (n(), l("p", $, p(e.title), 1)) : e.$slots.title ? (n(), l("div", y, [
        i(e.$slots, "title", {}, void 0, !0)
      ])) : u("", !0),
      (n(), h(f(e.angleDown)))
    ], 2),
    a("div", {
      class: "content-wrapper",
      style: g(e.getAccordionStyles)
    }, [
      a("div", {
        class: "content",
        ref: `${e.$.uid}-content`
      }, [
        i(e.$slots, "default", {}, void 0, !0)
      ], 512)
    ], 4)
  ], 16);
}
const D = /* @__PURE__ */ E(v, [["render", k], ["__scopeId", "data-v-0f7c915d"]]);
export {
  D as default
};
