import { PropType } from 'vue';
import { IAlertButton } from '../../interface';
declare const _default: import("vue").DefineComponent<{
    backdropBlur: {
        default: boolean;
        type: BooleanConstructor;
    };
    cancelButton: {
        required: false;
        type: PropType<IAlertButton>;
    };
    confirmButton: {
        required: false;
        type: PropType<IAlertButton>;
    };
    customClass: {
        required: false;
        type: StringConstructor;
    };
    duration: {
        required: true;
        type: NumberConstructor;
    };
    icon: {
        required: false;
        type: PropType<"info" | "warning" | "success" | "error" | "question" | "loading">;
    };
    positionX: {
        default: string;
        type: PropType<"left" | "center" | "right">;
    };
    positionY: {
        default: string;
        type: PropType<"top" | "conter" | "bottom">;
    };
    show: {
        required: true;
        type: BooleanConstructor;
    };
    text: {
        default: string;
        type: StringConstructor;
    };
    title: {
        default: string;
        type: StringConstructor;
    };
    variant: {
        default: string;
        type: PropType<"big" | "flat">;
    };
}, unknown, {
    localShow: boolean;
    maskClasses: string[];
}, {
    getIcon(): import("vue").VNode<import("vue").RendererNode, import("vue").RendererElement, {
        [key: string]: any;
    }>;
    iconXMark(): import("vue").VNode<import("vue").RendererNode, import("vue").RendererElement, {
        [key: string]: any;
    }>;
}, {
    doClose(action?: string): void;
    handleShow(value: boolean): void;
}, import("vue").ComponentOptionsMixin, import("vue").ComponentOptionsMixin, {
    close: (_action?: string) => boolean;
}, string, import("vue").VNodeProps & import("vue").AllowedComponentProps & import("vue").ComponentCustomProps, Readonly<import("vue").ExtractPropTypes<{
    backdropBlur: {
        default: boolean;
        type: BooleanConstructor;
    };
    cancelButton: {
        required: false;
        type: PropType<IAlertButton>;
    };
    confirmButton: {
        required: false;
        type: PropType<IAlertButton>;
    };
    customClass: {
        required: false;
        type: StringConstructor;
    };
    duration: {
        required: true;
        type: NumberConstructor;
    };
    icon: {
        required: false;
        type: PropType<"info" | "warning" | "success" | "error" | "question" | "loading">;
    };
    positionX: {
        default: string;
        type: PropType<"left" | "center" | "right">;
    };
    positionY: {
        default: string;
        type: PropType<"top" | "conter" | "bottom">;
    };
    show: {
        required: true;
        type: BooleanConstructor;
    };
    text: {
        default: string;
        type: StringConstructor;
    };
    title: {
        default: string;
        type: StringConstructor;
    };
    variant: {
        default: string;
        type: PropType<"big" | "flat">;
    };
}>> & {
    onClose?: ((_action?: string | undefined) => any) | undefined;
}, {
    title: string;
    text: string;
    variant: "big" | "flat";
    backdropBlur: boolean;
    positionX: "left" | "center" | "right";
    positionY: "top" | "conter" | "bottom";
}, {}>;
export default _default;
