import "./button.css";
import { defineComponent as a, resolveComponent as d, openBlock as i, createElementBlock as r, mergeProps as l, renderSlot as n, createBlock as p, withCtx as u, createElementVNode as b } from "vue";
import f from "../tooltip/tooltip.js";
import { _ as k } from "../../_plugin-vue_export-helper-dad06003.js";
const m = a({
  emits: {
    click: (e) => !0
  },
  props: {
    color: {
      default: "default",
      type: String
    },
    disabled: {
      default: !1,
      type: Boolean
    },
    noElevation: {
      required: !1,
      type: Boolean
    },
    size: {
      default: "base",
      type: String
    },
    tooltip: {
      required: !1,
      type: String
    },
    variant: {
      default: "contained",
      type: String
    }
  },
  name: "sb-button",
  components: {
    "sb-tooltip": f
  },
  data() {
    return { isClicked: !1 };
  },
  methods: {
    handleClick(e) {
      this.isClicked = !0, setTimeout(() => {
        this.isClicked = !1;
      }, 250), this.$emit("click", e);
    }
  }
});
const c = ["disabled"], C = ["disabled"];
function v(e, t, $, y, h, B) {
  const s = d("sb-tooltip");
  return e.tooltip ? (i(), p(s, l({
    key: 1,
    label: e.tooltip
  }, { ...e.$attrs }), {
    default: u(() => [
      b("button", l({
        class: ["btn", [
          `btn-${e.variant}`,
          e.size,
          e.color,
          e.isClicked && "clicked",
          e.noElevation && "no-elevation"
        ]],
        disabled: e.disabled
      }, { ...e.$attrs, class: void 0, style: void 0 }, {
        onClick: t[1] || (t[1] = (...o) => e.handleClick && e.handleClick(...o))
      }), [
        n(e.$slots, "default")
      ], 16, C)
    ]),
    _: 3
  }, 16, ["label"])) : (i(), r("button", l({
    key: 0,
    class: ["btn", [
      `btn-${e.variant}`,
      e.size,
      e.color,
      e.isClicked && "clicked",
      e.noElevation && "no-elevation"
    ]],
    disabled: e.disabled,
    onClick: t[0] || (t[0] = (...o) => e.handleClick && e.handleClick(...o))
  }, { ...e.$attrs }), [
    n(e.$slots, "default")
  ], 16, c));
}
const z = /* @__PURE__ */ k(m, [["render", v]]);
export {
  z as default
};
