import { PropType } from 'vue';
import { IResponsive } from '../../interface';
declare const _default: import("vue").DefineComponent<{
    arrow: {
        default: boolean;
        type: BooleanConstructor;
    };
    autoplay: {
        required: false;
        type: BooleanConstructor;
    };
    cardsToShow: {
        default: number;
        type: NumberConstructor;
    };
    dots: {
        default: boolean;
        type: BooleanConstructor;
    };
    infinite: {
        required: false;
        type: BooleanConstructor;
    };
    list: {
        required: true;
        type: PropType<any[]>;
    };
    responsive: {
        required: false;
        type: PropType<IResponsive[]>;
    };
    speed: {
        default: number;
        type: NumberConstructor;
    };
}, unknown, {
    autoplayInterval: any;
    cardWidth: number;
    cardsDisplay: any;
    carouselWrapper: any;
    currentPage: number;
    endDrag: number;
    isDrag: boolean;
    isMounted: boolean;
    isSmallScreen: boolean;
    localDots: any[];
    localResponsives: IResponsive[];
    sliderStyle: any;
    startDrag: number;
}, {
    iconAngleLeft(): import("vue").VNode<import("vue").RendererNode, import("vue").RendererElement, {
        [key: string]: any;
    }>;
    iconAngleRight(): import("vue").VNode<import("vue").RendererNode, import("vue").RendererElement, {
        [key: string]: any;
    }>;
    isDotsEnabled(): boolean;
    isInfinite(): boolean;
}, {
    getCardsToShow(): number;
    handleDot(page: number): void;
    handleDrag(ev: MouseEvent | TouchEvent): void;
    handleDragEnd(ev: MouseEvent | TouchEvent): void;
    handleDragStart(ev: MouseEvent | TouchEvent): void;
    handleInitCards(): void;
    handleNav(inc: number): void;
    handleResize(): void;
    handleScrollBasic(): void;
    handleScrollInfinite(inc: number): void;
    isCardActive(index: number): boolean;
    modifyCards(): any[];
    setSliderStyles(): void;
}, import("vue").ComponentOptionsMixin, import("vue").ComponentOptionsMixin, {}, string, import("vue").VNodeProps & import("vue").AllowedComponentProps & import("vue").ComponentCustomProps, Readonly<import("vue").ExtractPropTypes<{
    arrow: {
        default: boolean;
        type: BooleanConstructor;
    };
    autoplay: {
        required: false;
        type: BooleanConstructor;
    };
    cardsToShow: {
        default: number;
        type: NumberConstructor;
    };
    dots: {
        default: boolean;
        type: BooleanConstructor;
    };
    infinite: {
        required: false;
        type: BooleanConstructor;
    };
    list: {
        required: true;
        type: PropType<any[]>;
    };
    responsive: {
        required: false;
        type: PropType<IResponsive[]>;
    };
    speed: {
        default: number;
        type: NumberConstructor;
    };
}>>, {
    speed: number;
    autoplay: boolean;
    cardsToShow: number;
    arrow: boolean;
    dots: boolean;
    infinite: boolean;
}, {}>;
export default _default;
