import "./color-picker.css";
import { defineComponent as n, openBlock as r, createElementBlock as s, mergeProps as d, normalizeClass as o, createElementVNode as t, toDisplayString as c, createCommentVNode as i, Fragment as u, renderList as p, normalizeStyle as h } from "vue";
import { _ as m } from "../../_plugin-vue_export-helper-dad06003.js";
const g = n({
  emits: {
    "update:modelValue": (e) => !0,
    change: (e) => !0
  },
  props: {
    errorMessage: {
      required: !1,
      type: [String, Function]
    },
    isError: {
      required: !1,
      type: Boolean
    },
    label: {
      required: !1,
      type: String
    },
    list: {
      required: !0,
      type: Object
    },
    modelValue: {
      required: !1,
      type: String
    },
    value: {
      required: !1,
      type: String
    }
  },
  name: "sb-color-picker",
  data() {
    return {
      selected: this.modelValue || this.value || null
    };
  },
  methods: {
    doSelect(e) {
      this.selected = e, this.$nextTick(() => {
        this.$emit("update:modelValue", this.selected), this.$emit("change", this.selected);
      });
    },
    handleErrorMessage() {
      return this.errorMessage ? typeof this.errorMessage == "string" ? this.errorMessage : this.errorMessage(this.selected) : "";
    },
    isSelected(e) {
      return this.selected ? this.selected === e : !1;
    }
  },
  watch: {
    modelValue: {
      deep: !0,
      handler(e) {
        this.selected = e;
      }
    },
    value: {
      deep: !0,
      handler(e) {
        this.selected = e;
      }
    }
  }
});
const _ = { class: "input-group colors-wrapper" }, f = ["onClick"], y = {
  key: 1,
  class: "error-wrapper"
}, k = ["innerHTML"];
function v(e, M, S, $, b, E) {
  return r(), s("div", d({ class: "color-wrapper" }, { ...e.$attrs }), [
    e.label ? (r(), s("label", {
      key: 0,
      class: o(["label", {
        error: e.isError && e.errorMessage
      }])
    }, [
      t("span", null, c(e.label), 1)
    ], 2)) : i("", !0),
    t("div", _, [
      (r(!0), s(u, null, p(e.list, (l, a) => (r(), s("div", {
        class: o([{
          selected: e.isSelected(l)
        }, "color"]),
        key: a,
        onClick: (V) => e.doSelect(l)
      }, [
        t("div", {
          style: h({ background: l })
        }, null, 4)
      ], 10, f))), 128))
    ]),
    e.isError && e.errorMessage ? (r(), s("div", y, [
      t("span", {
        innerHTML: e.handleErrorMessage()
      }, null, 8, k)
    ])) : i("", !0)
  ], 16);
}
const w = /* @__PURE__ */ m(g, [["render", v], ["__scopeId", "data-v-6c83ec1c"]]);
export {
  w as default
};
