import { PropType } from 'vue';
import { IAutocompleteItem, IIcon } from '../../interface';
declare const _default: import("vue").DefineComponent<{
    disabled: {
        required: false;
        type: BooleanConstructor;
    };
    errorMessage: {
        required: false;
        type: (StringConstructor | FunctionConstructor)[];
    };
    flat: {
        required: false;
        type: BooleanConstructor;
    };
    isError: {
        required: false;
        type: BooleanConstructor;
    };
    isLoading: {
        required: false;
        type: BooleanConstructor;
    };
    label: {
        required: false;
        type: StringConstructor;
    };
    list: {
        required: false;
        type: PropType<IAutocompleteItem[]>;
    };
    loadingText: {
        default: string;
        type: StringConstructor;
    };
    modelValue: {
        required: false;
        type: PropType<String | null>;
    };
    placeholder: {
        required: false;
        type: StringConstructor;
    };
    readOnly: {
        required: false;
        type: BooleanConstructor;
    };
    required: {
        required: false;
        type: BooleanConstructor;
    };
    value: {
        required: false;
        type: PropType<String | null>;
    };
}, unknown, {
    activeOption: number;
    elem: any;
    icon: IIcon;
    isFocus: boolean;
    isOpen: boolean;
    localList: any[];
    localTerm: string;
    optWrapperStyles: {
        left: string;
        top: string;
        width: string;
    };
    parentWithScroll: any;
}, {}, {
    doSelect(value: any): void;
    handleArrowEvent(inc: number, event: KeyboardEvent): void;
    handleBackdropClick(): void;
    handleFilterList(term: string): void;
    handleInput(ev: any): void;
    handleKeyEvent(event: KeyboardEvent): void;
    handleOpen(): void;
    handleParentBlur(event: FocusEvent): void;
    handleParentFocus(): void;
    handleParentScroll(isOpen: boolean): void;
    handleRemoveFocus(): void;
    handleUpdateModel(value: any): void;
    setOptionsPosition(): {
        left: string;
        top: string;
        width: string;
    } | undefined;
}, import("vue").ComponentOptionsMixin, import("vue").ComponentOptionsMixin, {
    'update:modelValue': (_selected: any) => boolean;
    change: (_selected: any) => boolean;
    input: (_term: string) => boolean;
}, string, import("vue").VNodeProps & import("vue").AllowedComponentProps & import("vue").ComponentCustomProps, Readonly<import("vue").ExtractPropTypes<{
    disabled: {
        required: false;
        type: BooleanConstructor;
    };
    errorMessage: {
        required: false;
        type: (StringConstructor | FunctionConstructor)[];
    };
    flat: {
        required: false;
        type: BooleanConstructor;
    };
    isError: {
        required: false;
        type: BooleanConstructor;
    };
    isLoading: {
        required: false;
        type: BooleanConstructor;
    };
    label: {
        required: false;
        type: StringConstructor;
    };
    list: {
        required: false;
        type: PropType<IAutocompleteItem[]>;
    };
    loadingText: {
        default: string;
        type: StringConstructor;
    };
    modelValue: {
        required: false;
        type: PropType<String | null>;
    };
    placeholder: {
        required: false;
        type: StringConstructor;
    };
    readOnly: {
        required: false;
        type: BooleanConstructor;
    };
    required: {
        required: false;
        type: BooleanConstructor;
    };
    value: {
        required: false;
        type: PropType<String | null>;
    };
}>> & {
    onChange?: ((_selected: any) => any) | undefined;
    onInput?: ((_term: string) => any) | undefined;
    "onUpdate:modelValue"?: ((_selected: any) => any) | undefined;
}, {
    flat: boolean;
    required: boolean;
    disabled: boolean;
    isError: boolean;
    loadingText: string;
    readOnly: boolean;
    isLoading: boolean;
}, {}>;
export default _default;
