import { PropType } from 'vue';
import { ICheckItem } from '../../interface';
declare const _default: import("vue").DefineComponent<{
    disabled: {
        required: false;
        type: BooleanConstructor;
    };
    errorMessage: {
        required: false;
        type: (StringConstructor | FunctionConstructor)[];
    };
    isError: {
        required: false;
        type: BooleanConstructor;
    };
    label: {
        required: false;
        type: StringConstructor;
    };
    list: {
        required: true;
        type: PropType<ICheckItem[]>;
    };
    modelValue: {
        required: false;
        type: PropType<ICheckItem[] | null>;
    };
    readOnly: {
        required: false;
        type: BooleanConstructor;
    };
    required: {
        required: false;
        type: BooleanConstructor;
    };
    value: {
        required: false;
        type: PropType<ICheckItem[] | null>;
    };
}, unknown, {
    selected: ICheckItem[] | null;
}, {
    check(): import("vue").VNode<import("vue").RendererNode, import("vue").RendererElement, {
        [key: string]: any;
    }>;
}, {
    doSelect(item: ICheckItem): void;
    handleErrorMessage(): any;
    handleKeydown(ev: KeyboardEvent, item: ICheckItem): void;
    isSelected(item: ICheckItem): boolean;
}, import("vue").ComponentOptionsMixin, import("vue").ComponentOptionsMixin, {
    'update:modelValue': (_selected: ICheckItem[] | null) => boolean;
    change: (_selected: ICheckItem[] | null) => boolean;
    input: (_selected: ICheckItem[] | null) => boolean;
}, string, import("vue").VNodeProps & import("vue").AllowedComponentProps & import("vue").ComponentCustomProps, Readonly<import("vue").ExtractPropTypes<{
    disabled: {
        required: false;
        type: BooleanConstructor;
    };
    errorMessage: {
        required: false;
        type: (StringConstructor | FunctionConstructor)[];
    };
    isError: {
        required: false;
        type: BooleanConstructor;
    };
    label: {
        required: false;
        type: StringConstructor;
    };
    list: {
        required: true;
        type: PropType<ICheckItem[]>;
    };
    modelValue: {
        required: false;
        type: PropType<ICheckItem[] | null>;
    };
    readOnly: {
        required: false;
        type: BooleanConstructor;
    };
    required: {
        required: false;
        type: BooleanConstructor;
    };
    value: {
        required: false;
        type: PropType<ICheckItem[] | null>;
    };
}>> & {
    onChange?: ((_selected: ICheckItem[] | null) => any) | undefined;
    onInput?: ((_selected: ICheckItem[] | null) => any) | undefined;
    "onUpdate:modelValue"?: ((_selected: ICheckItem[] | null) => any) | undefined;
}, {
    required: boolean;
    disabled: boolean;
    isError: boolean;
    readOnly: boolean;
}, {}>;
export default _default;
