import { PropType } from 'vue';
declare const _default: import("vue").DefineComponent<{
    disabled: {
        required: false;
        type: BooleanConstructor;
    };
    isOpen: {
        required: true;
        type: BooleanConstructor;
    };
    multi: {
        required: false;
        type: BooleanConstructor;
    };
    onBlur: {
        required: false;
        type: PropType<() => void>;
    };
    onFocus: {
        required: false;
        type: PropType<() => void>;
    };
    onDelete: {
        required: false;
        type: PropType<(_index?: number) => void>;
    };
    onFilter: {
        required: false;
        type: PropType<(_term: string) => void>;
    };
    optLabel: {
        required: true;
        type: (StringConstructor | FunctionConstructor)[];
    };
    placeholder: {
        required: false;
        type: StringConstructor;
    };
    readOnly: {
        required: false;
        type: BooleanConstructor;
    };
    selected: {
        required: false;
        type: PropType<any>;
    };
}, unknown, {
    termMulti: string;
    termSingle: string;
}, {
    isEmpty(): any;
}, {
    handleBlur(): void;
    handleFocus(): void;
    handleSearchSelected(ev: any): void;
    handleClear(index?: number): void;
    handleFilterList(term: string): void;
    handleSearchInput(ev: any): void;
    renderOption(opt: any): any;
}, import("vue").ComponentOptionsMixin, import("vue").ComponentOptionsMixin, {
    onBlur: () => boolean;
}, string, import("vue").VNodeProps & import("vue").AllowedComponentProps & import("vue").ComponentCustomProps, Readonly<import("vue").ExtractPropTypes<{
    disabled: {
        required: false;
        type: BooleanConstructor;
    };
    isOpen: {
        required: true;
        type: BooleanConstructor;
    };
    multi: {
        required: false;
        type: BooleanConstructor;
    };
    onBlur: {
        required: false;
        type: PropType<() => void>;
    };
    onFocus: {
        required: false;
        type: PropType<() => void>;
    };
    onDelete: {
        required: false;
        type: PropType<(_index?: number) => void>;
    };
    onFilter: {
        required: false;
        type: PropType<(_term: string) => void>;
    };
    optLabel: {
        required: true;
        type: (StringConstructor | FunctionConstructor)[];
    };
    placeholder: {
        required: false;
        type: StringConstructor;
    };
    readOnly: {
        required: false;
        type: BooleanConstructor;
    };
    selected: {
        required: false;
        type: PropType<any>;
    };
}>> & {
    onOnBlur?: (() => any) | undefined;
}, {
    disabled: boolean;
    multi: boolean;
    readOnly: boolean;
}, {}>;
export default _default;
