import { PropType } from 'vue';
import { IServerSide, IServerSideHandler } from '../../../interface';
declare const _default: import("vue").DefineComponent<{
    activeOption: {
        required: true;
        type: NumberConstructor;
    };
    infinite: {
        required: false;
        type: BooleanConstructor;
    };
    isOpen: {
        required: true;
        type: BooleanConstructor;
    };
    isScrollBottom: {
        required: true;
        type: BooleanConstructor;
    };
    loadingText: {
        default: string;
        type: StringConstructor;
    };
    multi: {
        required: false;
        type: BooleanConstructor;
    };
    noResultText: {
        default: string;
        type: StringConstructor;
    };
    onAjax: {
        required: false;
        type: PropType<(_resp: IServerSideHandler, _type: string | 'BEFORE SEND' | 'ERROR' | 'SUCCESS', _isLoadMore?: boolean) => void>;
    };
    optLabel: {
        required: true;
        type: (StringConstructor | FunctionConstructor)[];
    };
    selected: {
        required: false;
        type: PropType<any>;
    };
    serverSide: {
        required: false;
        type: PropType<IServerSide>;
    };
    term: {
        required: true;
        type: StringConstructor;
    };
}, unknown, {
    localAbort: any;
    localList: any[];
    localLoading: boolean;
    localPage: number;
}, {}, {
    doSelect(opt: any): void;
    handleAjax(): Promise<void>;
    isSelected(opt: any): any;
    renderOption(opt: any): any;
}, import("vue").ComponentOptionsMixin, import("vue").ComponentOptionsMixin, {
    listChange: (_list: any[]) => boolean;
    loading: (_isLoading: boolean) => boolean;
    select: (_option: any, _isSelected?: boolean) => boolean;
}, string, import("vue").VNodeProps & import("vue").AllowedComponentProps & import("vue").ComponentCustomProps, Readonly<import("vue").ExtractPropTypes<{
    activeOption: {
        required: true;
        type: NumberConstructor;
    };
    infinite: {
        required: false;
        type: BooleanConstructor;
    };
    isOpen: {
        required: true;
        type: BooleanConstructor;
    };
    isScrollBottom: {
        required: true;
        type: BooleanConstructor;
    };
    loadingText: {
        default: string;
        type: StringConstructor;
    };
    multi: {
        required: false;
        type: BooleanConstructor;
    };
    noResultText: {
        default: string;
        type: StringConstructor;
    };
    onAjax: {
        required: false;
        type: PropType<(_resp: IServerSideHandler, _type: string | 'BEFORE SEND' | 'ERROR' | 'SUCCESS', _isLoadMore?: boolean) => void>;
    };
    optLabel: {
        required: true;
        type: (StringConstructor | FunctionConstructor)[];
    };
    selected: {
        required: false;
        type: PropType<any>;
    };
    serverSide: {
        required: false;
        type: PropType<IServerSide>;
    };
    term: {
        required: true;
        type: StringConstructor;
    };
}>> & {
    onSelect?: ((_option: any, _isSelected?: boolean | undefined) => any) | undefined;
    onLoading?: ((_isLoading: boolean) => any) | undefined;
    onListChange?: ((_list: any[]) => any) | undefined;
}, {
    infinite: boolean;
    loadingText: string;
    multi: boolean;
    noResultText: string;
}, {}>;
export default _default;
