import "./form-input-mask.css";
import { defineComponent as W, resolveDirective as j, openBlock as f, createElementBlock as g, mergeProps as C, createElementVNode as m, normalizeClass as M, toDisplayString as F, createCommentVNode as E, withModifiers as U, renderSlot as J, withDirectives as z, vModelText as D, Fragment as R, createTextVNode as H } from "vue";
import { _ as Z } from "../../_plugin-vue_export-helper-dad06003.js";
/*! maska v2.1.10 | (c) Alexander Shabunevich | Released under the MIT license */
var K = Object.defineProperty, G = (e, s, t) => s in e ? K(e, s, { enumerable: !0, configurable: !0, writable: !0, value: t }) : e[s] = t, b = (e, s, t) => (G(e, typeof s != "symbol" ? s + "" : s, t), t);
const S = {
  "#": { pattern: /[0-9]/ },
  "@": { pattern: /[a-zA-Z]/ },
  "*": { pattern: /[a-zA-Z0-9]/ }
};
class L {
  constructor(s = {}) {
    b(this, "opts", {}), b(this, "memo", /* @__PURE__ */ new Map());
    const t = { ...s };
    if (t.tokens != null) {
      t.tokens = t.tokensReplace ? { ...t.tokens } : { ...S, ...t.tokens };
      for (const a of Object.values(t.tokens))
        typeof a.pattern == "string" && (a.pattern = new RegExp(a.pattern));
    } else
      t.tokens = S;
    Array.isArray(t.mask) && (t.mask.length > 1 ? t.mask = [...t.mask].sort((a, n) => a.length - n.length) : t.mask = t.mask[0] ?? ""), t.mask === "" && (t.mask = null), this.opts = t;
  }
  masked(s) {
    return this.process(s, this.findMask(s));
  }
  unmasked(s) {
    return this.process(s, this.findMask(s), !1);
  }
  isEager() {
    return this.opts.eager === !0;
  }
  isReversed() {
    return this.opts.reversed === !0;
  }
  completed(s) {
    const t = this.findMask(s);
    if (this.opts.mask == null || t == null)
      return !1;
    const a = this.process(s, t).length;
    return typeof this.opts.mask == "string" ? a >= this.opts.mask.length : typeof this.opts.mask == "function" ? a >= t.length : this.opts.mask.filter((n) => a >= n.length).length === this.opts.mask.length;
  }
  findMask(s) {
    const t = this.opts.mask;
    if (t == null)
      return null;
    if (typeof t == "string")
      return t;
    if (typeof t == "function")
      return t(s);
    const a = this.process(s, t.slice(-1).pop() ?? "", !1);
    return t.find((n) => this.process(s, n, !1).length >= a.length) ?? "";
  }
  escapeMask(s) {
    const t = [], a = [];
    return s.split("").forEach((n, o) => {
      n === "!" && s[o - 1] !== "!" ? a.push(o - a.length) : t.push(n);
    }), { mask: t.join(""), escaped: a };
  }
  process(s, t, a = !0) {
    var n;
    if (t == null)
      return s;
    const o = `value=${s},mask=${t},masked=${a ? 1 : 0}`;
    if (this.memo.has(o))
      return this.memo.get(o);
    const { mask: l, escaped: u } = this.escapeMask(t), p = [], h = this.opts.tokens != null ? this.opts.tokens : {}, i = this.isReversed() ? -1 : 1, k = this.isReversed() ? "unshift" : "push", O = this.isReversed() ? 0 : l.length - 1, B = this.isReversed() ? () => r > -1 && d > -1 : () => r < l.length && d < s.length, N = (v) => !this.isReversed() && v <= O || this.isReversed() && v >= O;
    let q, y = -1, r = this.isReversed() ? l.length - 1 : 0, d = this.isReversed() ? s.length - 1 : 0;
    for (; B(); ) {
      const v = l.charAt(r), c = h[v], V = (c == null ? void 0 : c.transform) != null ? c.transform(s.charAt(d)) : s.charAt(d);
      if (!u.includes(r) && c != null) {
        if (V.match(c.pattern) != null)
          p[k](V), c.repeated ? (y === -1 ? y = r : r === O && r !== y && (r = y - i), O === y && (r -= i)) : c.multiple && (r -= i), r += i;
        else if (c.multiple) {
          const P = ((n = p[d - i]) == null ? void 0 : n.match(c.pattern)) != null, w = l.charAt(r + i);
          P && w !== "" && h[w] == null ? (r += i, d -= i) : p[k]("");
        } else
          V === q ? q = void 0 : c.optional && (r += i, d -= i);
        d += i;
      } else
        a && !this.isEager() && p[k](v), V === v && !this.isEager() ? d += i : q = v, this.isEager() || (r += i);
      if (this.isEager())
        for (; N(r) && (h[l.charAt(r)] == null || u.includes(r)); )
          a ? p[k](l.charAt(r)) : l.charAt(r) === s.charAt(d) && (d += i), r += i;
    }
    return this.memo.set(o, p.join("")), this.memo.get(o);
  }
}
const $ = (e) => JSON.parse(e.replaceAll("'", '"')), T = (e, s = {}) => {
  const t = { ...s };
  return e.dataset.maska != null && e.dataset.maska !== "" && (t.mask = Q(e.dataset.maska)), e.dataset.maskaEager != null && (t.eager = A(e.dataset.maskaEager)), e.dataset.maskaReversed != null && (t.reversed = A(e.dataset.maskaReversed)), e.dataset.maskaTokensReplace != null && (t.tokensReplace = A(e.dataset.maskaTokensReplace)), e.dataset.maskaTokens != null && (t.tokens = X(e.dataset.maskaTokens)), t;
}, A = (e) => e !== "" ? !!JSON.parse(e) : !0, Q = (e) => e.startsWith("[") && e.endsWith("]") ? $(e) : e, X = (e) => {
  if (e.startsWith("{") && e.endsWith("}"))
    return $(e);
  const s = {};
  return e.split("|").forEach((t) => {
    const a = t.split(":");
    s[a[0]] = {
      pattern: new RegExp(a[1]),
      optional: a[2] === "optional",
      multiple: a[2] === "multiple",
      repeated: a[2] === "repeated"
    };
  }), s;
};
class Y {
  constructor(s, t = {}) {
    b(this, "items", /* @__PURE__ */ new Map()), b(this, "beforeinputEvent", (a) => {
      const n = a.target, o = this.items.get(n);
      o.isEager() && "inputType" in a && a.inputType.startsWith("delete") && o.unmasked(n.value).length <= 1 && this.setMaskedValue(n, "");
    }), b(this, "inputEvent", (a) => {
      if (a instanceof CustomEvent && a.type === "input" && a.detail != null && typeof a.detail == "object" && "masked" in a.detail)
        return;
      const n = a.target, o = this.items.get(n), l = n.value, u = n.selectionStart, p = n.selectionEnd;
      let h = l;
      if (o.isEager()) {
        const i = o.masked(l), k = o.unmasked(l);
        k === "" && "data" in a && a.data != null ? h = a.data : k !== o.unmasked(i) && (h = k);
      }
      if (this.setMaskedValue(n, h), "inputType" in a && (a.inputType.startsWith("delete") || u != null && u < l.length))
        try {
          n.setSelectionRange(u, p);
        } catch {
        }
    }), this.options = t, typeof s == "string" ? this.init(
      Array.from(document.querySelectorAll(s)),
      this.getMaskOpts(t)
    ) : this.init(
      "length" in s ? Array.from(s) : [s],
      this.getMaskOpts(t)
    );
  }
  destroy() {
    for (const s of this.items.keys())
      s.removeEventListener("input", this.inputEvent), s.removeEventListener("beforeinput", this.beforeinputEvent);
    this.items.clear();
  }
  needUpdateOptions(s, t) {
    const a = this.items.get(s), n = new L(T(s, this.getMaskOpts(t)));
    return JSON.stringify(a.opts) !== JSON.stringify(n.opts);
  }
  needUpdateValue(s) {
    const t = s.dataset.maskaValue;
    return t == null && s.value !== "" || t != null && t !== s.value;
  }
  getMaskOpts(s) {
    const { onMaska: t, preProcess: a, postProcess: n, ...o } = s;
    return o;
  }
  init(s, t) {
    for (const a of s) {
      const n = new L(T(a, t));
      this.items.set(a, n), a.value !== "" && this.setMaskedValue(a, a.value), a.addEventListener("input", this.inputEvent), a.addEventListener("beforeinput", this.beforeinputEvent);
    }
  }
  setMaskedValue(s, t) {
    const a = this.items.get(s);
    this.options.preProcess != null && (t = this.options.preProcess(t));
    const n = a.masked(t), o = a.unmasked(a.isEager() ? n : t), l = a.completed(t), u = { masked: n, unmasked: o, completed: l };
    t = n, this.options.postProcess != null && (t = this.options.postProcess(t)), s.value = t, s.dataset.maskaValue = t, this.options.onMaska != null && (Array.isArray(this.options.onMaska) ? this.options.onMaska.forEach((p) => p(u)) : this.options.onMaska(u)), s.dispatchEvent(new CustomEvent("maska", { detail: u })), s.dispatchEvent(new CustomEvent("input", { detail: u }));
  }
}
const I = /* @__PURE__ */ new WeakMap(), _ = (e) => {
  setTimeout(() => {
    var s;
    ((s = I.get(e)) == null ? void 0 : s.needUpdateValue(e)) === !0 && e.dispatchEvent(new CustomEvent("input"));
  });
}, x = (e, s) => {
  const t = e instanceof HTMLInputElement ? e : e.querySelector("input"), a = { ...s.arg };
  if (t == null || (t == null ? void 0 : t.type) === "file")
    return;
  _(t);
  const n = I.get(t);
  if (n != null) {
    if (!n.needUpdateOptions(t, a))
      return;
    n.destroy();
  }
  if (s.value != null) {
    const o = s.value, l = (u) => {
      o.masked = u.masked, o.unmasked = u.unmasked, o.completed = u.completed;
    };
    a.onMaska = a.onMaska == null ? l : Array.isArray(a.onMaska) ? [...a.onMaska, l] : [a.onMaska, l];
  }
  I.set(t, new Y(t, a));
}, ee = W({
  emits: {
    "update:modelValue": (e) => !0,
    blur: (e) => !0,
    focus: (e) => !0,
    input: (e) => !0,
    keydown: (e) => !0
  },
  props: {
    autocomplete: {
      required: !1,
      type: Boolean
    },
    disabled: {
      required: !1,
      type: Boolean
    },
    errorMessage: {
      required: !1,
      type: [String, Function]
    },
    icon: {
      required: !1,
      type: Object
    },
    isError: {
      required: !1,
      type: Boolean
    },
    isFocus: {
      required: !1,
      type: Boolean
    },
    label: {
      required: !1,
      type: String
    },
    maskaOptions: {
      required: !1,
      type: Object
    },
    modelValue: {
      required: !1,
      type: null
    },
    pattern: {
      required: !1,
      type: String
    },
    placeholder: {
      required: !1,
      type: String
    },
    readOnly: {
      required: !1,
      type: Boolean
    },
    required: {
      required: !1,
      type: Boolean
    },
    tabindex: {
      required: !1,
      type: Number
    },
    textAlign: {
      default: "left",
      type: String
    },
    value: {
      required: !1,
      type: null
    },
    variant: {
      default: "default",
      required: !1,
      type: String
    }
  },
  name: "sb-form-input",
  directives: {
    maska: x
  },
  data() {
    return {
      localIsFocus: !1,
      localValue: this.modelValue || this.value || null
    };
  },
  computed: {
    getMaskaOptions() {
      return {
        ...this.pattern && {
          mask: this.pattern
        },
        ...this.maskaOptions && {
          ...this.maskaOptions
        }
      };
    },
    isFilled() {
      return this.localValue && (this.localValue !== "" || this.localValue.length);
    }
  },
  methods: {
    handleBlur(e) {
      this.localIsFocus = !1, this.$emit("blur", e);
    },
    handleChange(e) {
      this.$emit("input", e), this.$emit("update:modelValue", this.localValue);
    },
    handleClickIcon(e) {
      var s;
      return ((s = this.icon) == null ? void 0 : s.onClick) && this.icon.onClick(e);
    },
    handleClickOutsideInput(e) {
      const s = e.target, t = this.$refs["input-wrapper"];
      s && t && !t.contains(s) && !s.isSameNode(t) && this.toggleFocus(!1);
    },
    handleErrorMessage() {
      return this.errorMessage ? typeof this.errorMessage == "string" ? this.errorMessage : this.errorMessage(this.localValue) : "";
    },
    handleInputFocus(e) {
      this.localIsFocus = !0, this.$emit("focus", e);
    },
    handleMouseLeaveIcon(e) {
      var s;
      return ((s = this.icon) == null ? void 0 : s.onMouseLeave) && this.icon.onMouseLeave(e);
    },
    handleMouseOverIcon(e) {
      var s;
      return ((s = this.icon) == null ? void 0 : s.onMouseOver) && this.icon.onMouseOver(e);
    },
    toggleFocus(e, s) {
      if (s) {
        const t = s.target, a = t == null ? void 0 : t.querySelectorAll("input");
        a.length > 0 && a[0].focus();
      }
      this.localIsFocus = e;
    }
  },
  watch: {
    isFocus(e) {
      this.localIsFocus = e;
    },
    modelValue: {
      handler(e) {
        this.localValue = e;
      }
    },
    value: {
      handler(e) {
        this.localValue = e;
      }
    }
  },
  mounted() {
    document.addEventListener(
      "click",
      (e) => this.handleClickOutsideInput(e)
    );
  },
  unmounted() {
    document.removeEventListener(
      "click",
      (e) => this.handleClickOutsideInput(e)
    );
  }
});
const se = {
  key: 0,
  class: "asterisk"
}, te = ["autocomplete", "tabindex"], ae = { class: "input-border" }, ne = { class: "notch" }, ie = {
  key: 0,
  class: "asterisk"
}, oe = {
  key: 0,
  class: "error-wrapper"
}, le = ["innerHTML"];
function re(e, s, t, a, n, o) {
  var u, p, h;
  const l = j("maska");
  return f(), g("div", C({
    class: ["input-wrapper", { error: e.isError, flat: e.variant === "flat" }],
    ref: "input-wrapper"
  }, { ...e.$attrs }), [
    m("div", {
      class: M(["input-group", {
        disabled: e.disabled,
        filled: e.isFilled,
        focus: e.isFocus || e.localIsFocus,
        icon_append: ((u = e.icon) == null ? void 0 : u.placement) === "append",
        icon_prepend: ((p = e.icon) == null ? void 0 : p.placement) === "prepend",
        readonly: e.readOnly
      }])
    }, [
      e.label ? (f(), g("label", {
        key: 0,
        class: M(["label", { required: e.required }])
      }, [
        m("span", null, F(e.label), 1),
        e.required ? (f(), g("span", se, "*")) : E("", !0)
      ], 2)) : E("", !0),
      e.icon ? (f(), g("span", {
        key: 1,
        class: M([{
          "sb-cursor-pointer": (h = e.icon) == null ? void 0 : h.onClick
        }, "icon"]),
        onClick: s[0] || (s[0] = U((...i) => e.handleClickIcon && e.handleClickIcon(...i), ["stop"])),
        onMouseover: s[1] || (s[1] = (...i) => e.handleMouseOverIcon && e.handleMouseOverIcon(...i)),
        onMouseleave: s[2] || (s[2] = (...i) => e.handleMouseLeaveIcon && e.handleMouseLeaveIcon(...i))
      }, [
        J(e.$slots, "icon-slot")
      ], 34)) : E("", !0),
      m("div", {
        class: M(["form-control", ["text", e.textAlign]]),
        onClick: s[8] || (s[8] = (i) => e.toggleFocus(!0, i))
      }, [
        z(m("input", C({
          autocomplete: e.autocomplete ? "on" : "off",
          tabindex: e.readOnly || e.disabled ? -1 : e.tabindex,
          type: "text",
          "onUpdate:modelValue": s[3] || (s[3] = (i) => e.localValue = i)
        }, {
          disabled: e.disabled,
          placeholder: e.placeholder,
          readonly: e.readOnly
        }, {
          onBlur: s[4] || (s[4] = (i) => e.handleBlur(i)),
          onFocus: s[5] || (s[5] = (i) => e.handleInputFocus(i)),
          onInput: s[6] || (s[6] = (i) => e.handleChange(i)),
          onKeydown: s[7] || (s[7] = (i) => e.$emit("keydown", i))
        }), null, 16, te), [
          [l, void 0, e.getMaskaOptions],
          [D, e.localValue]
        ])
      ], 2),
      m("fieldset", ae, [
        m("legend", ne, [
          m("span", {
            class: M(["notch-label", { "no-label": !e.label || e.label === "" }])
          }, [
            e.label && e.label !== "" ? (f(), g(R, { key: 0 }, [
              m("span", null, F(e.label), 1),
              e.required ? (f(), g("span", ie, "*")) : E("", !0)
            ], 64)) : (f(), g(R, { key: 1 }, [
              H("​")
            ], 64))
          ], 2)
        ])
      ])
    ], 2),
    e.isError && e.errorMessage ? (f(), g("div", oe, [
      m("span", {
        innerHTML: e.handleErrorMessage()
      }, null, 8, le)
    ])) : E("", !0)
  ], 16);
}
const de = /* @__PURE__ */ Z(ee, [["render", re]]);
export {
  de as default
};
