import { IIcon } from '../../interface';
import { PropType } from 'vue';
declare const _default: import("vue").DefineComponent<{
    autocomplete: {
        required: false;
        type: BooleanConstructor;
    };
    disabled: {
        required: false;
        type: BooleanConstructor;
    };
    errorMessage: {
        required: false;
        type: (StringConstructor | FunctionConstructor)[];
    };
    icon: {
        required: false;
        type: PropType<IIcon>;
    };
    isError: {
        required: false;
        type: BooleanConstructor;
    };
    isFocus: {
        required: false;
        type: BooleanConstructor;
    };
    label: {
        required: false;
        type: StringConstructor;
    };
    max: {
        required: false;
        type: (StringConstructor | NumberConstructor)[];
    };
    min: {
        required: false;
        type: (StringConstructor | NumberConstructor)[];
    };
    modelValue: {
        required: false;
        type: PropType<string | number | object | null>;
    };
    name: {
        required: false;
        type: StringConstructor;
    };
    noSavePassword: {
        required: false;
        type: BooleanConstructor;
    };
    placeholder: {
        required: false;
        type: StringConstructor;
    };
    readOnly: {
        required: false;
        type: BooleanConstructor;
    };
    required: {
        required: false;
        type: BooleanConstructor;
    };
    step: {
        required: false;
        type: NumberConstructor;
    };
    tabindex: {
        required: false;
        type: NumberConstructor;
    };
    textAlign: {
        default: string;
        type: PropType<"left" | "right">;
    };
    type: {
        default: string;
        type: PropType<string>;
    };
    value: {
        required: false;
        type: PropType<string | number | object | null>;
    };
    variant: {
        default: string;
        required: false;
        type: PropType<"default" | "flat">;
    };
}, unknown, {
    localIsFocus: boolean;
    localValue: any;
}, {
    getInputType(): string;
    isFilled(): any;
}, {
    handleBlur(ev: Event): void;
    handleChange(ev: Event): void;
    handleClickIcon(ev: Event): void | undefined;
    handleClickOutsideInput(event: MouseEvent): void;
    handleErrorMessage(): any;
    handleInputFocus(ev: Event): void;
    handleMouseLeaveIcon(ev: Event): void | undefined;
    handleMouseOverIcon(ev: Event): void | undefined;
    toggleFocus(focus: boolean, event?: Event): void;
}, import("vue").ComponentOptionsMixin, import("vue").ComponentOptionsMixin, {
    'update:modelValue': (_value: any) => boolean;
    blur: (_event: Event) => boolean;
    focus: (_event: Event) => boolean;
    input: (_event: Event) => boolean;
    keydown: (_event: Event) => boolean;
}, string, import("vue").VNodeProps & import("vue").AllowedComponentProps & import("vue").ComponentCustomProps, Readonly<import("vue").ExtractPropTypes<{
    autocomplete: {
        required: false;
        type: BooleanConstructor;
    };
    disabled: {
        required: false;
        type: BooleanConstructor;
    };
    errorMessage: {
        required: false;
        type: (StringConstructor | FunctionConstructor)[];
    };
    icon: {
        required: false;
        type: PropType<IIcon>;
    };
    isError: {
        required: false;
        type: BooleanConstructor;
    };
    isFocus: {
        required: false;
        type: BooleanConstructor;
    };
    label: {
        required: false;
        type: StringConstructor;
    };
    max: {
        required: false;
        type: (StringConstructor | NumberConstructor)[];
    };
    min: {
        required: false;
        type: (StringConstructor | NumberConstructor)[];
    };
    modelValue: {
        required: false;
        type: PropType<string | number | object | null>;
    };
    name: {
        required: false;
        type: StringConstructor;
    };
    noSavePassword: {
        required: false;
        type: BooleanConstructor;
    };
    placeholder: {
        required: false;
        type: StringConstructor;
    };
    readOnly: {
        required: false;
        type: BooleanConstructor;
    };
    required: {
        required: false;
        type: BooleanConstructor;
    };
    step: {
        required: false;
        type: NumberConstructor;
    };
    tabindex: {
        required: false;
        type: NumberConstructor;
    };
    textAlign: {
        default: string;
        type: PropType<"left" | "right">;
    };
    type: {
        default: string;
        type: PropType<string>;
    };
    value: {
        required: false;
        type: PropType<string | number | object | null>;
    };
    variant: {
        default: string;
        required: false;
        type: PropType<"default" | "flat">;
    };
}>> & {
    onFocus?: ((_event: Event) => any) | undefined;
    onBlur?: ((_event: Event) => any) | undefined;
    onInput?: ((_event: Event) => any) | undefined;
    onKeydown?: ((_event: Event) => any) | undefined;
    "onUpdate:modelValue"?: ((_value: any) => any) | undefined;
}, {
    type: string;
    required: boolean;
    disabled: boolean;
    variant: "default" | "flat";
    isError: boolean;
    isFocus: boolean;
    autocomplete: boolean;
    noSavePassword: boolean;
    readOnly: boolean;
    textAlign: "left" | "right";
}, {}>;
export default _default;
