import { IRadioItem } from '../../interface';
import { PropType } from 'vue';
declare const _default: import("vue").DefineComponent<{
    disabled: {
        required: false;
        type: BooleanConstructor;
    };
    errorMessage: {
        required: false;
        type: (StringConstructor | FunctionConstructor)[];
    };
    isError: {
        required: false;
        type: BooleanConstructor;
    };
    label: {
        required: false;
        type: StringConstructor;
    };
    list: {
        required: true;
        type: PropType<IRadioItem[]>;
    };
    modelValue: {
        required: false;
        type: PropType<IRadioItem | null>;
    };
    readOnly: {
        required: false;
        type: BooleanConstructor;
    };
    required: {
        required: false;
        type: BooleanConstructor;
    };
    value: {
        required: false;
        type: PropType<IRadioItem | null>;
    };
}, unknown, {
    selected: IRadioItem | null;
}, {}, {
    doSelect(value: IRadioItem): void;
    handleErrorMessage(): any;
    handleKeydown(ev: KeyboardEvent, radio: IRadioItem): void;
    isSelected(item: IRadioItem): boolean;
}, import("vue").ComponentOptionsMixin, import("vue").ComponentOptionsMixin, {
    'update:modelValue': (_selected: IRadioItem | null) => boolean;
    change: (_selected: IRadioItem | null) => boolean;
    input: (_selected: IRadioItem | null) => boolean;
}, string, import("vue").VNodeProps & import("vue").AllowedComponentProps & import("vue").ComponentCustomProps, Readonly<import("vue").ExtractPropTypes<{
    disabled: {
        required: false;
        type: BooleanConstructor;
    };
    errorMessage: {
        required: false;
        type: (StringConstructor | FunctionConstructor)[];
    };
    isError: {
        required: false;
        type: BooleanConstructor;
    };
    label: {
        required: false;
        type: StringConstructor;
    };
    list: {
        required: true;
        type: PropType<IRadioItem[]>;
    };
    modelValue: {
        required: false;
        type: PropType<IRadioItem | null>;
    };
    readOnly: {
        required: false;
        type: BooleanConstructor;
    };
    required: {
        required: false;
        type: BooleanConstructor;
    };
    value: {
        required: false;
        type: PropType<IRadioItem | null>;
    };
}>> & {
    onChange?: ((_selected: IRadioItem | null) => any) | undefined;
    onInput?: ((_selected: IRadioItem | null) => any) | undefined;
    "onUpdate:modelValue"?: ((_selected: IRadioItem | null) => any) | undefined;
}, {
    required: boolean;
    disabled: boolean;
    isError: boolean;
    readOnly: boolean;
}, {}>;
export default _default;
