import { PropType } from 'vue';
import EditorJS, { ToolConstructable, ToolSettings } from '@editorjs/editorjs';
import { IWysiwygOutputData } from '../../interface';
declare const _default: import("vue").DefineComponent<{
    errorMessage: {
        required: false;
        type: (StringConstructor | FunctionConstructor)[];
    };
    isError: {
        required: false;
        type: BooleanConstructor;
    };
    label: {
        required: false;
        type: StringConstructor;
    };
    modelValue: {
        required: false;
        type: PropType<IWysiwygOutputData | null>;
    };
    tools: {
        required: false;
        type: PropType<Record<string, ToolConstructable | ToolSettings>>;
    };
    readOnly: {
        required: false;
        type: BooleanConstructor;
    };
    required: {
        required: false;
        type: BooleanConstructor;
    };
    tabindex: {
        required: false;
        type: NumberConstructor;
    };
    value: {
        required: false;
        type: PropType<IWysiwygOutputData | null>;
    };
}, unknown, {
    localIsFocus: boolean;
    localValue: any;
    stateEditor: {
        editor: EditorJS | null;
        isReady: boolean;
    };
}, {
    getId(): string;
}, {
    doRenderData(data: IWysiwygOutputData | null): void;
    handleChange(): void;
    handleErrorMessage(): any;
    handleToggleFocus(): void;
}, import("vue").ComponentOptionsMixin, import("vue").ComponentOptionsMixin, {
    'update:modelValue': (_value: any) => true;
    change: (_event: Event) => true;
    input: (_event: Event) => true;
}, string, import("vue").VNodeProps & import("vue").AllowedComponentProps & import("vue").ComponentCustomProps, Readonly<import("vue").ExtractPropTypes<{
    errorMessage: {
        required: false;
        type: (StringConstructor | FunctionConstructor)[];
    };
    isError: {
        required: false;
        type: BooleanConstructor;
    };
    label: {
        required: false;
        type: StringConstructor;
    };
    modelValue: {
        required: false;
        type: PropType<IWysiwygOutputData | null>;
    };
    tools: {
        required: false;
        type: PropType<Record<string, ToolConstructable | ToolSettings>>;
    };
    readOnly: {
        required: false;
        type: BooleanConstructor;
    };
    required: {
        required: false;
        type: BooleanConstructor;
    };
    tabindex: {
        required: false;
        type: NumberConstructor;
    };
    value: {
        required: false;
        type: PropType<IWysiwygOutputData | null>;
    };
}>> & {
    onChange?: ((_event: Event) => any) | undefined;
    onInput?: ((_event: Event) => any) | undefined;
    "onUpdate:modelValue"?: ((_value: any) => any) | undefined;
}, {
    required: boolean;
    isError: boolean;
    readOnly: boolean;
}, {}>;
export default _default;
