import "./menu.css";
import { defineComponent as u, resolveComponent as m, openBlock as n, createElementBlock as s, normalizeProps as f, guardReactiveProps as v, createElementVNode as r, createVNode as y, mergeProps as S, withModifiers as l, withCtx as b, renderSlot as p, createTextVNode as g, toDisplayString as P, createBlock as $, Teleport as W, normalizeStyle as w, createCommentVNode as C } from "vue";
import k from "../button/button.js";
import { r as a } from "../../helper-15d8bd47.js";
import { _ as B } from "../../_plugin-vue_export-helper-dad06003.js";
import "../tooltip/tooltip.js";
const O = u({
  props: {
    color: {
      default: "default",
      type: String
    },
    disabled: {
      default: !1,
      type: Boolean
    },
    label: {
      required: !1,
      type: String
    },
    noElevation: {
      required: !1,
      type: Boolean
    },
    open: {
      required: !1,
      type: Boolean
    },
    size: {
      default: "base",
      type: String
    },
    tooltip: {
      required: !1,
      type: String
    },
    variant: {
      default: "contained",
      type: String
    }
  },
  name: "sb-menu",
  components: {
    "sb-button": k
  },
  data() {
    return {
      localOpen: !1,
      itemsWrapperStyles: [],
      parentWithScroll: null
    };
  },
  methods: {
    handleClose() {
      this.localOpen = !1;
    },
    handleOpen() {
      this.disabled || (this.localOpen = !0, this.$nextTick(() => {
        this.setPopupPosition();
      }));
    },
    handleParentScroll(e) {
      const t = a(this.$el);
      this.parentWithScroll && this.parentWithScroll.removeEventListener("scroll", () => {
        this.setPopupPosition();
      }), t && (e ? t.addEventListener("scroll", () => {
        this.setPopupPosition();
      }) : t.removeEventListener("scroll", () => {
        this.setPopupPosition();
      })), this.$nextTick(() => {
        this.parentWithScroll = t;
      });
    },
    setPopupPosition() {
      var t;
      const e = this.$refs["menu-wrapper"];
      if (e) {
        const o = e.getBoundingClientRect(), i = (t = this.$refs["menu-items-wrapper"]) == null ? void 0 : t.getBoundingClientRect();
        if (i)
          return document.body.getBoundingClientRect().height - (o.height + o.y) <= i.height ? this.itemsWrapperStyles = {
            left: `${o.x}px`,
            top: `${o.y - 6 - i.height}px`,
            width: `${o.width}px`
          } : this.itemsWrapperStyles = {
            left: `${o.x}px`,
            top: `${o.y + o.height}px`,
            width: `${o.width}px`
          };
      }
    }
  },
  watch: {
    localOpen(e) {
      this.handleParentScroll(e);
    }
  },
  mounted() {
    this.localOpen = this.open, this.$nextTick(() => this.setPopupPosition()), this.parentWithScroll = a(this.$el);
  },
  unmounted() {
    this.parentWithScroll && this.parentWithScroll.removeEventListener("scroll", () => {
      this.setPopupPosition();
    });
  }
});
const E = {
  class: "menu-wrapper",
  ref: "menu-wrapper"
};
function _(e, t, o, i, d, T) {
  const h = m("sb-button");
  return n(), s("div", f(v({ ...e.$attrs })), [
    r("div", E, [
      y(h, S({
        "no-elevation": e.localOpen || e.noElevation,
        type: "button"
      }, {
        color: e.color,
        disabled: e.disabled,
        size: e.size,
        tooltip: e.tooltip,
        variant: e.variant
      }, {
        onClick: l(e.handleOpen, ["stop"])
      }), {
        default: b(() => [
          p(e.$slots, "slot-label", {}, () => [
            g(P(e.label || "..."), 1)
          ], !0)
        ]),
        _: 3
      }, 16, ["no-elevation", "onClick"])
    ], 512),
    (n(), $(W, { to: "body" }, [
      e.localOpen ? (n(), s("div", {
        key: 0,
        class: "menu-backdrop",
        onClick: t[0] || (t[0] = l((...c) => e.handleClose && e.handleClose(...c), ["stop"]))
      }, [
        r("div", {
          class: "menu-items-wrapper",
          ref: "menu-items-wrapper",
          style: w(e.itemsWrapperStyles)
        }, [
          p(e.$slots, "default", {}, void 0, !0)
        ], 4)
      ])) : C("", !0)
    ]))
  ], 16);
}
const V = /* @__PURE__ */ B(O, [["render", _], ["__scopeId", "data-v-51c3b940"]]);
export {
  V as default
};
