import { PropType } from 'vue';
import { IStepperItem } from '../../interface';
declare const _default: import("vue").DefineComponent<{
    alternateTitle: {
        required: false;
        type: BooleanConstructor;
    };
    hideFooter: {
        required: false;
        type: BooleanConstructor;
    };
    interceptNav: {
        required: false;
        type: PropType<((_target: number) => boolean) | ((_target: number) => Promise<boolean>)>;
    };
    isDetail: {
        required: false;
        type: BooleanConstructor;
    };
    items: {
        required: true;
        type: PropType<IStepperItem[]>;
    };
    mobile: {
        required: false;
        type: BooleanConstructor;
    };
    modelValue: {
        required: true;
        type: NumberConstructor;
    };
    nonLinear: {
        required: false;
        type: BooleanConstructor;
    };
    type: {
        default: string;
        type: PropType<"horizontal" | "vertical">;
    };
}, unknown, {
    isButtonDisabled: boolean;
    localCurrent: number;
    localItems: any[];
}, {
    getNextColor(): any;
    getNextText(): any;
    getPrevColor(): any;
    getPrevText(): any;
    getSkipText(): any;
    iconCheck(): import("vue").VNode<import("vue").RendererNode, import("vue").RendererElement, {
        [key: string]: any;
    }>;
    iconPen(): import("vue").VNode<import("vue").RendererNode, import("vue").RendererElement, {
        [key: string]: any;
    }>;
    iconXMark(): import("vue").VNode<import("vue").RendererNode, import("vue").RendererElement, {
        [key: string]: any;
    }>;
    isNextDisabled(): boolean;
}, {
    doNavigate(inc: number): void;
    handleClickHead(index: number): Promise<void>;
    handleNav(inc: number, isSkip?: boolean): Promise<void>;
    isError(rules?: (() => boolean)[]): boolean;
    isFilled(index: number): boolean;
}, import("vue").ComponentOptionsMixin, import("vue").ComponentOptionsMixin, {
    'update:modelValue': (_active: number) => boolean;
    change: (_active: number) => boolean;
    finish: () => boolean;
}, string, import("vue").VNodeProps & import("vue").AllowedComponentProps & import("vue").ComponentCustomProps, Readonly<import("vue").ExtractPropTypes<{
    alternateTitle: {
        required: false;
        type: BooleanConstructor;
    };
    hideFooter: {
        required: false;
        type: BooleanConstructor;
    };
    interceptNav: {
        required: false;
        type: PropType<((_target: number) => boolean) | ((_target: number) => Promise<boolean>)>;
    };
    isDetail: {
        required: false;
        type: BooleanConstructor;
    };
    items: {
        required: true;
        type: PropType<IStepperItem[]>;
    };
    mobile: {
        required: false;
        type: BooleanConstructor;
    };
    modelValue: {
        required: true;
        type: NumberConstructor;
    };
    nonLinear: {
        required: false;
        type: BooleanConstructor;
    };
    type: {
        default: string;
        type: PropType<"horizontal" | "vertical">;
    };
}>> & {
    onChange?: ((_active: number) => any) | undefined;
    "onUpdate:modelValue"?: ((_active: number) => any) | undefined;
    onFinish?: (() => any) | undefined;
}, {
    type: "horizontal" | "vertical";
    alternateTitle: boolean;
    hideFooter: boolean;
    isDetail: boolean;
    mobile: boolean;
    nonLinear: boolean;
}, {}>;
export default _default;
