import "./tooltip.css";
import { defineComponent as r, openBlock as i, createElementBlock as a, normalizeProps as p, guardReactiveProps as l, createBlock as d, Teleport as m, normalizeClass as c, normalizeStyle as g, toDisplayString as h, createCommentVNode as u, createElementVNode as w, renderSlot as b } from "vue";
import { _ as f } from "../../_plugin-vue_export-helper-dad06003.js";
const v = r({
  props: {
    hidden: {
      required: !1,
      type: Boolean
    },
    label: {
      required: !0,
      type: String
    }
  },
  name: "sb-tooltip",
  data() {
    return {
      rect: {
        left: "0",
        top: "0"
      },
      show: !1
    };
  },
  computed: {
    isMobile() {
      const e = navigator.userAgent || window.opera;
      return !!(/(android|bb\d+|meego).+mobile|avantgo|bada\/|blackberry|blazer|compal|elaine|fennec|hiptop|iemobile|ip(hone|od)|iris|kindle|lge |maemo|midp|mmp|mobile.+firefox|netfront|opera m(ob|in)i|palm( os)?|phone|p(ixi|re)\/|plucker|pocket|psp|series(4|6)0|symbian|treo|up\.(browser|link)|vodafone|wap|windows ce|xda|xiino|android|ipad|playbook|silk/i.test(
        e
      ) || /1207|6310|6590|3gso|4thp|50[1-6]i|770s|802s|a wa|abac|ac(er|oo|s-)|ai(ko|rn)|al(av|ca|co)|amoi|an(ex|ny|yw)|aptu|ar(ch|go)|as(te|us)|attw|au(di|-m|r |s )|avan|be(ck|ll|nq)|bi(lb|rd)|bl(ac|az)|br(e|v)w|bumb|bw-(n|u)|c55\/|capi|ccwa|cdm-|cell|chtm|cldc|cmd-|co(mp|nd)|craw|da(it|ll|ng)|dbte|dc-s|devi|dica|dmob|do(c|p)o|ds(12|-d)|el(49|ai)|em(l2|ul)|er(ic|k0)|esl8|ez([4-7]0|os|wa|ze)|fetc|fly(-|_)|g1 u|g560|gene|gf-5|g-mo|go(\.w|od)|gr(ad|un)|haie|hcit|hd-(m|p|t)|hei-|hi(pt|ta)|hp( i|ip)|hs-c|ht(c(-| |_|a|g|p|s|t)|tp)|hu(aw|tc)|i-(20|go|ma)|i230|iac( |-|\/)|ibro|idea|ig01|ikom|im1k|inno|ipaq|iris|ja(t|v)a|jbro|jemu|jigs|kddi|keji|kgt( |\/)|klon|kpt |kwc-|kyo(c|k)|le(no|xi)|lg( g|\/(k|l|u)|50|54|-[a-w])|libw|lynx|m1-w|m3ga|m50\/|ma(te|ui|xo)|mc(01|21|ca)|m-cr|me(rc|ri)|mi(o8|oa|ts)|mmef|mo(01|02|bi|de|do|t(-| |o|v)|zz)|mt(50|p1|v )|mwbp|mywa|n10[0-2]|n20[2-3]|n30(0|2)|n50(0|2|5)|n7(0(0|1)|10)|ne((c|m)-|on|tf|wf|wg|wt)|nok(6|i)|nzph|o2im|op(ti|wv)|oran|owg1|p800|pan(a|d|t)|pdxg|pg(13|-([1-8]|c))|phil|pire|pl(ay|uc)|pn-2|po(ck|rt|se)|prox|psio|pt-g|qa-a|qc(07|12|21|32|60|-[2-7]|i-)|qtek|r380|r600|raks|rim9|ro(ve|zo)|s55\/|sa(ge|ma|mm|ms|ny|va)|sc(01|h-|oo|p-)|sdk\/|se(c(-|0|1)|47|mc|nd|ri)|sgh-|shar|sie(-|m)|sk-0|sl(45|id)|sm(al|ar|b3|it|t5)|so(ft|ny)|sp(01|h-|v-|v )|sy(01|mb)|t2(18|50)|t6(00|10|18)|ta(gt|lk)|tcl-|tdg-|tel(i|m)|tim-|t-mo|to(pl|sh)|ts(70|m-|m3|m5)|tx-9|up(\.b|g1|si)|utst|v400|v750|veri|vi(rg|te)|vk(40|5[0-3]|-v)|vm40|voda|vulc|vx(52|53|60|61|70|80|81|83|85|98)|w3c(-| )|webc|whit|wi(g |nc|nw)|wmlb|wonu|x700|yas-|your|zeto|zte-/i.test(
        e.substr(0, 4)
      ));
    }
  },
  methods: {
    handlePopupPosition() {
      if (this.$refs["content-wrapper"] && this.$refs.tooltip) {
        const e = this.$refs["content-wrapper"].getBoundingClientRect(), t = this.$refs.tooltip.getBoundingClientRect(), o = e.width / 2 - t.width / 2 + e.left;
        document.body.getBoundingClientRect().height - (e.height + e.y) <= t.height + 6 ? this.rect = {
          left: `${o < 0 ? 6 : o}px`,
          top: `${e.top - e.height - 6}px`
        } : this.rect = {
          left: `${o < 0 ? 6 : o}px`,
          top: `${e.top + e.height + 6}px`
        };
      }
    },
    toggleShow(e) {
      this.show = e, this.$nextTick(() => this.handlePopupPosition());
    }
  }
});
function k(e, t, o, n, y, $) {
  return i(), a("div", p(l({ ...e.$attrs })), [
    (i(), d(m, { to: "body" }, [
      e.show && !e.isMobile && !e.hidden ? (i(), a("div", {
        key: 0,
        class: c(["tooltip", { hide: e.isMobile || e.hidden, show: e.show }]),
        style: g(e.rect),
        ref: "tooltip"
      }, h(e.label), 7)) : u("", !0)
    ])),
    w("div", {
      onMouseleave: t[0] || (t[0] = (s) => e.toggleShow(!1)),
      onMouseover: t[1] || (t[1] = (s) => e.toggleShow(!0)),
      class: "content-wrapper",
      ref: "content-wrapper"
    }, [
      b(e.$slots, "default", {}, void 0, !0)
    ], 544)
  ], 16);
}
const B = /* @__PURE__ */ f(v, [["render", k], ["__scopeId", "data-v-3b55881f"]]);
export {
  B as default
};
