import { PropType } from 'vue';
import { ITreeItem } from '../../interface';
declare const _default: import("vue").DefineComponent<{
    checkBox: {
        required: false;
        type: BooleanConstructor;
    };
    expanded: {
        required: false;
        type: BooleanConstructor;
    };
    item: {
        required: true;
        type: PropType<ITreeItem>;
    };
    multi: {
        required: false;
        type: BooleanConstructor;
    };
    selected: {
        required: false;
        type: PropType<Record<any, ITreeItem>>;
    };
}, unknown, {
    localExpand: boolean;
}, {
    iconAngleRight(): import("vue").VNode<import("vue").RendererNode, import("vue").RendererElement, {
        [key: string]: any;
    }>;
    iconCheck(): import("vue").VNode<import("vue").RendererNode, import("vue").RendererElement, {
        [key: string]: any;
    }>;
}, {
    handleEmitDeselect(item: ITreeItem | ITreeItem[]): void;
    handleEmitExpand(item: ITreeItem, isExpanded: boolean): void;
    handleEmitSelect(item: ITreeItem | ITreeItem[]): void;
    handleCheck(item: ITreeItem): void;
    handleClick(item: ITreeItem): void;
    isAllChecked(item: ITreeItem): boolean;
    isPartialChecked(item: ITreeItem): boolean;
    isSelected(item: ITreeItem): boolean;
    toggleExpand(item: ITreeItem): void;
}, import("vue").ComponentOptionsMixin, import("vue").ComponentOptionsMixin, {
    deselect: (_item: ITreeItem | ITreeItem[]) => true;
    expand: (_item: ITreeItem, _isExpanded: boolean) => true;
    select: (_item: ITreeItem | ITreeItem[]) => true;
}, string, import("vue").VNodeProps & import("vue").AllowedComponentProps & import("vue").ComponentCustomProps, Readonly<import("vue").ExtractPropTypes<{
    checkBox: {
        required: false;
        type: BooleanConstructor;
    };
    expanded: {
        required: false;
        type: BooleanConstructor;
    };
    item: {
        required: true;
        type: PropType<ITreeItem>;
    };
    multi: {
        required: false;
        type: BooleanConstructor;
    };
    selected: {
        required: false;
        type: PropType<Record<any, ITreeItem>>;
    };
}>> & {
    onSelect?: ((_item: ITreeItem | ITreeItem[]) => any) | undefined;
    onExpand?: ((_item: ITreeItem, _isExpanded: boolean) => any) | undefined;
    onDeselect?: ((_item: ITreeItem | ITreeItem[]) => any) | undefined;
}, {
    expanded: boolean;
    multi: boolean;
    checkBox: boolean;
}, {}>;
export default _default;
